﻿using System;
using System.Collections.Generic;
using System.Text;

namespace _11_Ubg_Mailverteiler_Mo
{
    // Firma A
    delegate void Callback(string s);  // definiert den neuen Datentyp Callback
    delegate void Transformiere(ref string s); // ref ermöglicht die Veränderung des Inhalts!!!
    class MessageBox
    {
        public event Callback Verteiler;
        public event Transformiere Transform;
          // Event = Einschränkung
          //   * Nur += und -= von außerhalb erlaubt
          //   * Aufruf der Event-Var nur durch Methoden von MessageBox

        public void Send(string s)
        {
            Transform?.Invoke(ref s);
            // Etwaige Vorarbeiten vor dem Aufruf
            Verteiler?.Invoke(s);  // Verteiler(s)
                    // ?. ~  (Verteiler == null) ? null : Verteiler.Invoke(s) 
            // Etwaige Nacharbeiten
        }
    }
}
