﻿using System;

namespace _02_UebgMo
{
    // Programmieren Sie eine Klasse Kennzeichen mit folgenden privaten Eigenschaften
    // string kennzeichen
    // int position

    // - statischer Konstruktor: Erzeugt ein Feld (statisch/nicht-statisch?)
    //    von verfügbaren Kennzeichen.

    // - Konstruktor: Nimmt das nächste verfügbare Kennzeichen aus dem Feld und initialisiert das Objekt damit. Dann wird das
    //      betreffende Kennzeichen im Kennzeichenfeld gelöscht (=null). In der position-Variablen wird die Feldnummer gespeichert.

    // - Methode: Kennzeichenzurückgeben: Erhält ein Kennzeichen und schreibt dieses Kennzeichen dann wieder in das Kennzeichenfeld
    //      an die betreffende Position zurück.

    class Kennzeichen
    {
        string kennz;
        int pos;

        static string[] verfuegbar; // = { "N-AB-100", "N-AB-101" };    NUR EINMAL FÜR DIE KLASSE!!!
        static int nPos = 0;

        static Kennzeichen()
        {
            Console.WriteLine("Statischer Konstruktor");
            verfuegbar = new string[20];
            for (int i = 0; i < verfuegbar.Length; i++)
                verfuegbar[i] = $"N-AB-{i + 100}";
        }
        public Kennzeichen()
        {
            Console.WriteLine("new()");
            for (int i = 0; i < verfuegbar.Length; i++)
            {
                int p = (i + nPos) % verfuegbar.Length;
                if (verfuegbar[p] != null)
                {
                    kennz = verfuegbar[p];
                    pos = p;
                    verfuegbar[p] = null;
                    nPos++;
                    return;
                }
            }
            throw new Exception("Keine Kennzeichen mehr verfügbar!");
        }
        public void KennzeichenZurueck()
        {
            verfuegbar[pos] = kennz;
            kennz = null;
        }
    }
    class Program
    {
        static void Main(string[] args)
        {
            Console.WriteLine("Programmstart");
            Kennzeichen k1 = new Kennzeichen();     // N-AB-100
            Kennzeichen k2 = new Kennzeichen();     // N-AB-101

            k1.KennzeichenZurueck();                // N-AB-100 wurde zurückgegeben
            Kennzeichen k3 = new Kennzeichen();     // N-AB-100   bzw. N-AB-102
        }
    }
}
 