﻿using System;

namespace _11_Button
{
    delegate void TueEtwas(string s);
    class Button   // Kommt von Microsoft
    {
        public event Action<string> Click=null;
        // event ist eine EINSCHRÄNKUNG DES DELEGATES

        public void OnClick(string s)
        {
            //if (Click != null)
            //    Click(s);

            Click?.Invoke(s);
        }
    }

    class DummyA
    {
        string name;
        public DummyA(string n) { name = n; }
        public void meineDummyAAusgabe(string s)
        {
            Console.WriteLine($"Mein Objekt {name}: {s}");
        }
    }
    class DummyB
    {
        public static void meineDummyBAusgabe(string s)
        {
            Console.WriteLine($"Dummy-B Ausgabe: {s}");
        }
    }
    class Program
    {
        static void InGrossbuchstaben(string s)
        {
            Console.WriteLine(s.ToUpper());
        }
        static void Main(string[] args)
        {
            Button btn1 = new Button();
            btn1.Click += Console.WriteLine;
            btn1.Click += InGrossbuchstaben;
            btn1.Click += s => Console.WriteLine(s.ToLower());
            btn1.Click += DummyB.meineDummyBAusgabe;

            DummyA dummyA = new DummyA("Anton");
            DummyA dummyB = new DummyA("Berta");
            DummyA dummyC = new DummyA("Claudia");
            btn1.Click += dummyA.meineDummyAAusgabe;
            btn1.Click += dummyB.meineDummyAAusgabe;
            btn1.Click += dummyC.meineDummyAAusgabe;

            //btn1.Click -= InGrossbuchstaben;
            //btn1.Click -= s => Console.WriteLine(s.ToLower());

            btn1.OnClick("Hallo Button");  // Desktop-Manager
            btn1.OnClick("Zweiter Aufruf");  // Desktop-Manager



        }
    }
}
