﻿using System;

namespace _11_DelegateDataDriven
{
    class MyInt
    {
        int x;
        public MyInt(int X) { x = X; }
        public event Action<int> Ausgabeaufbereitung;

        public int Wert
        {
            get => x;
            set
            {
                x = value;
                Ausgabeaufbereitung?.Invoke(x);
            }
        }
    }
    class Program
    {
        static void Numerisch(int k)
        {
            Console.WriteLine($"Numerisch: {k}");
        }
        static void Balken(int k)
        {
            for (int i = 0; i < k; i++)
            {
                Console.Write("X");
            }
            Console.WriteLine();
        }
        static void Main(string[] args)
        {
            MyInt mi = new MyInt(10);
            mi.Ausgabeaufbereitung += Numerisch;
            mi.Ausgabeaufbereitung += Balken;
            mi.Wert = 20;
            mi.Wert += 10;
            mi.Ausgabeaufbereitung -= Numerisch;
            mi.Wert--;
        }
    }
}
