﻿using System;

namespace _11_Ubg_Mailverteiler_Mo
{
    // Legen Sie ein Delegate void Callback(string s) an
    // Erstellen Sie eine Klasse MessageBox mit
    //   - Einem Event verteiler
    //   - Einer Methode Send(string s), welche die verteiler Variable aufruft

    // Experimentieren Sie ...
    //  1) Legen Sie zwei Dummy-Klassen ClassA und ClassB an. Beide Klassen sollen
    //     öffentliche Methoden (statisch/nicht-statisch) besitzen, die der
    //     Callback-Signatur entsprechen
    //  2) Definieren Sie auch in Main noch eine statische Methode,
    //     die der Callback-Signatur entspricht
    //  3) Legen Sie eine Instanz der MessageBox an und registrieren Sie die
    //     Methoden in der Event-Variablen
    //  4) Rufen Sie Send() mit einem Text auf
    //  5) Entfernen Sie eine der registrierten Methoden und geben Sie noch
    //     einen Text aus


    // Firma B

    class DummyA
    {
        int a = 0;
        public void Ausgabe(string text)
        {
            Console.WriteLine($"{text}: {++a} mal aufgerufen");
        }
    }
    class DummyB
    {
        public static void PrintUpperCase(string txt)
        {
            Console.WriteLine($"{txt.ToUpper()}");
        }
    }
    class Program
    {
        static void Signatur(ref string s)
        {
            s = s + "\nViele Grüße von der TH Nürnberg";
        }
        static void Main(string[] args)
        {
            MessageBox mb = new MessageBox();
            DummyA a1 = new DummyA();
            DummyA a2 = new DummyA();

            mb.Verteiler += a1.Ausgabe;
            mb.Verteiler += a2.Ausgabe;
            mb.Verteiler += a2.Ausgabe;
            mb.Verteiler += DummyB.PrintUpperCase;
            // mb.Verteiler = Console.WriteLine;

            mb.Send("Erster Aufruf");
            Console.WriteLine("*************");

            mb.Transform += Signatur;
            mb.Send("Zweiter Aufruf");
            Console.WriteLine("*************");

            mb.Verteiler -= a2.Ausgabe;
            mb.Send("Dritter Aufruf");
        }
    }
}
