﻿using System;

namespace _12_staticVsNonstatic
{
    class xxx
    {
        int a;          // Jede Instanz von xxx hat ein eigenes a
        static int b;   // Genau ein b (unabhängig von der Anz. d. Instanzen)
        public xxx(int A) { a = A; }

        public void TueEtwas() { Console.WriteLine(this.a); }
        // Nicht-static Methoden erhalten eine Objektreferenz (this)
        public static void TueStatic() { Console.WriteLine(b); }
        // Eine static Methode kann NUR static Klassenvar. verwenden
        // Sie haben KEINEN this Parameter; Deshalb können  
        //    nicht-static Klassenvariablen nicht verwendet werden
    }
    class Program
    {
        static void Main(string[] args)
        {
            xxx x1 = new xxx(1);
            xxx x2 = new xxx(2);

            x1.TueEtwas();  // ~ TueEtwas(x1)
            xxx.TueStatic();
            // xxx.TueEtwas();  -- Nicht erlaubt! Objektref. erforderlich
        }
    }
}
